import "./cljs_env.js";
goog.provide('clojure_eval.extensions.close_brackets');
var module$node_modules$w3c_keyname$index_cjs=shadow.js.require("module$node_modules$w3c_keyname$index_cjs", {});
var module$node_modules$$codemirror$view$dist$index_cjs=shadow.js.require("module$node_modules$$codemirror$view$dist$index_cjs", {});
var module$node_modules$$codemirror$state$dist$index_cjs=shadow.js.require("module$node_modules$$codemirror$state$dist$index_cjs", {});
var module$node_modules$$codemirror$text$dist$index_cjs=shadow.js.require("module$node_modules$$codemirror$text$dist$index_cjs", {});
clojure_eval.extensions.close_brackets.in_string_QMARK_ = (function clojure_eval$extensions$close_brackets$in_string_QMARK_(state,pos){
var G__56439 = clojure_eval.node.name(clojure_eval.node.tree.cljs$core$IFn$_invoke$arity$2(state,pos));
var fexpr__56438 = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, ["StringContent",null,"String",null], null), null);
return (fexpr__56438.cljs$core$IFn$_invoke$arity$1 ? fexpr__56438.cljs$core$IFn$_invoke$arity$1(G__56439) : fexpr__56438.call(null,G__56439));
});
clojure_eval.extensions.close_brackets.escaped_QMARK_ = (function clojure_eval$extensions$close_brackets$escaped_QMARK_(state,pos){
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("\\",state.doc.slice((function (){var x__4306__auto__ = (0);
var y__4307__auto__ = (pos - (1));
return ((x__4306__auto__ > y__4307__auto__) ? x__4306__auto__ : y__4307__auto__);
})(),pos).toString());
});
clojure_eval.extensions.close_brackets.backspace_backoff = (function clojure_eval$extensions$close_brackets$backspace_backoff(state,from,to){
if(cljs.core.truth_((function (){var and__4221__auto__ = (function (){var G__56443 = clojure_eval.node.node_BAR_(state,(from - (1)));
if((G__56443 == null)){
return null;
} else {
return clojure_eval.util.guard(G__56443,clojure_eval.node.line_comment_QMARK_);
}
})();
if(cljs.core.truth_(and__4221__auto__)){
return (!(clojure.string.blank_QMARK_(clojure_eval.util.line_content_at(state,from))));
} else {
return and__4221__auto__;
}
})())){
return new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"cursor","cursor",1011937484),(from - (1))], null);
} else {
return clojure_eval.util.deletion.cljs$core$IFn$_invoke$arity$2(from,to);
}
});
/**
 * - skips over closing brackets
 * - when deleting an opening bracket of an empty list, removes both brackets
 */
clojure_eval.extensions.close_brackets.handle_backspace = (function clojure_eval$extensions$close_brackets$handle_backspace(p__56444){
var map__56445 = p__56444;
var map__56445__$1 = (((((!((map__56445 == null))))?(((((map__56445.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__56445.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__56445):map__56445);
var state = map__56445__$1;
var doc = (function (){var obj56447 = map__56445__$1;
var k56448 = "doc";
if((function (){var obj56449 = obj56447;
return (((!((obj56449 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k56448,obj56449)));
})()){
return (obj56447[k56448]);
} else {
return undefined;
}
})();
if(cljs.core.truth_((function (){var and__4221__auto__ = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((1),state.selection.ranges.length);
if(and__4221__auto__){
var range = (function (){var obj56454 = (function (){var obj56452 = (function (){var obj56450 = state;
var k56451 = "selection";
if((function (){var obj56456 = obj56450;
return (((!((obj56456 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k56451,obj56456)));
})()){
return (obj56450[k56451]);
} else {
return undefined;
}
})();
var k56453 = "ranges";
if((function (){var obj56457 = obj56452;
return (((!((obj56457 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k56453,obj56457)));
})()){
return (obj56452[k56453]);
} else {
return undefined;
}
})();
var k56455 = (0);
if((function (){var obj56458 = obj56454;
return (((!((obj56458 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k56455,obj56458)));
})()){
return (obj56454[k56455]);
} else {
return undefined;
}
})();
var and__4221__auto____$1 = range.empty;
if(cljs.core.truth_(and__4221__auto____$1)){
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((0),range.from);
} else {
return and__4221__auto____$1;
}
} else {
return and__4221__auto__;
}
})())){
return null;
} else {
return clojure_eval.util.update_ranges.cljs$core$IFn$_invoke$arity$3(state,({"annotations": clojure_eval.util.user_event_annotation("delete")}),(function (p__56459){
var map__56460 = p__56459;
var map__56460__$1 = (((((!((map__56460 == null))))?(((((map__56460.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__56460.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__56460):map__56460);
var range = map__56460__$1;
var head = (function (){var obj56462 = map__56460__$1;
var k56463 = "head";
if((function (){var obj56464 = obj56462;
return (((!((obj56464 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k56463,obj56464)));
})()){
return (obj56462[k56463]);
} else {
return undefined;
}
})();
var empty = (function (){var obj56465 = map__56460__$1;
var k56466 = "empty";
if((function (){var obj56467 = obj56465;
return (((!((obj56467 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k56466,obj56467)));
})()){
return (obj56465[k56466]);
} else {
return undefined;
}
})();
var anchor = (function (){var obj56468 = map__56460__$1;
var k56469 = "anchor";
if((function (){var obj56470 = obj56468;
return (((!((obj56470 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k56469,obj56470)));
})()){
return (obj56468[k56469]);
} else {
return undefined;
}
})();
var map__56471 = clojure_eval.util.from_to(head,anchor);
var map__56471__$1 = (((((!((map__56471 == null))))?(((((map__56471.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__56471.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__56471):map__56471);
var range__$1 = map__56471__$1;
var from = (function (){var obj56473 = map__56471__$1;
var k56474 = "from";
if((function (){var obj56475 = obj56473;
return (((!((obj56475 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k56474,obj56475)));
})()){
return (obj56473[k56474]);
} else {
return undefined;
}
})();
var to = (function (){var obj56476 = map__56471__$1;
var k56477 = "to";
if((function (){var obj56478 = obj56476;
return (((!((obj56478 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k56477,obj56478)));
})()){
return (obj56476[k56477]);
} else {
return undefined;
}
})();
var node_BAR_ = clojure_eval.node.tree.cljs$core$IFn$_invoke$arity$1(state).resolve(from,(-1));
var parent = node_BAR_.parent;
if(cljs.core.truth_((function (){var or__4223__auto__ = cljs.core.not(empty);
if(or__4223__auto__){
return or__4223__auto__;
} else {
var or__4223__auto____$1 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("StringContent",clojure_eval.node.name(clojure_eval.node.tree.cljs$core$IFn$_invoke$arity$3(state,from,(-1))));
if(or__4223__auto____$1){
return or__4223__auto____$1;
} else {
var and__4221__auto__ = parent;
if(cljs.core.truth_(and__4221__auto__)){
return (((!(clojure_eval.node.balanced_QMARK_(parent)))) && (clojure_eval.node.left_edge_QMARK_(node_BAR_)));
} else {
return and__4221__auto__;
}
}
}
})())){
return clojure_eval.util.deletion.cljs$core$IFn$_invoke$arity$2(from,to);
} else {
if(((clojure_eval.node.right_edge_QMARK_(node_BAR_)) && ((from === clojure_eval.node.end(parent))))){
return new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"cursor","cursor",1011937484),(from - (1))], null);
} else {
if(((((clojure_eval.node.start_edge_QMARK_(node_BAR_)) || (clojure_eval.node.same_edge_QMARK_(node_BAR_)))) && ((clojure_eval.node.start(node_BAR_) === clojure_eval.node.start(parent))))){
if(clojure_eval.node.empty_QMARK_(clojure_eval.node.up(node_BAR_))){
return new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"cursor","cursor",1011937484),clojure_eval.node.start(parent),new cljs.core.Keyword(null,"changes","changes",1492088),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [clojure_eval.util.from_to(clojure_eval.node.start(parent),clojure_eval.node.end(parent))], null)], null);
} else {
return new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"cursor","cursor",1011937484),from], null);
}
} else {
return clojure_eval.extensions.close_brackets.backspace_backoff(state,from,to);

}
}
}
}));
}
});
clojure_eval.extensions.close_brackets.coll_pairs = new cljs.core.PersistentArrayMap(null, 4, ["(",")","[","]","{","}","\"","\""], null);
clojure_eval.extensions.close_brackets.handle_open = (function clojure_eval$extensions$close_brackets$handle_open(state,open){
var close = (clojure_eval.extensions.close_brackets.coll_pairs.cljs$core$IFn$_invoke$arity$1 ? clojure_eval.extensions.close_brackets.coll_pairs.cljs$core$IFn$_invoke$arity$1(open) : clojure_eval.extensions.close_brackets.coll_pairs.call(null,open));
return clojure_eval.util.update_ranges.cljs$core$IFn$_invoke$arity$3(state,({"annotations": clojure_eval.util.user_event_annotation("input")}),(function (p__56479){
var map__56480 = p__56479;
var map__56480__$1 = (((((!((map__56480 == null))))?(((((map__56480.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__56480.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__56480):map__56480);
var from = (function (){var obj56482 = map__56480__$1;
var k56483 = "from";
if((function (){var obj56484 = obj56482;
return (((!((obj56484 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k56483,obj56484)));
})()){
return (obj56482[k56483]);
} else {
return undefined;
}
})();
var to = (function (){var obj56485 = map__56480__$1;
var k56486 = "to";
if((function (){var obj56487 = obj56485;
return (((!((obj56487 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k56486,obj56487)));
})()){
return (obj56485[k56486]);
} else {
return undefined;
}
})();
var head = (function (){var obj56488 = map__56480__$1;
var k56489 = "head";
if((function (){var obj56490 = obj56488;
return (((!((obj56490 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k56489,obj56490)));
})()){
return (obj56488[k56489]);
} else {
return undefined;
}
})();
var anchor = (function (){var obj56491 = map__56480__$1;
var k56492 = "anchor";
if((function (){var obj56493 = obj56491;
return (((!((obj56493 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k56492,obj56493)));
})()){
return (obj56491[k56492]);
} else {
return undefined;
}
})();
var empty = (function (){var obj56494 = map__56480__$1;
var k56495 = "empty";
if((function (){var obj56496 = obj56494;
return (((!((obj56496 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k56495,obj56496)));
})()){
return (obj56494[k56495]);
} else {
return undefined;
}
})();
if(cljs.core.truth_(clojure_eval.extensions.close_brackets.in_string_QMARK_(state,from))){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(open,"\"")){
return clojure_eval.util.insertion.cljs$core$IFn$_invoke$arity$2(head,"\\\"");
} else {
return clojure_eval.util.insertion.cljs$core$IFn$_invoke$arity$3(from,to,open);
}
} else {
if(clojure_eval.extensions.close_brackets.escaped_QMARK_(state,from)){
return clojure_eval.util.insertion.cljs$core$IFn$_invoke$arity$3(from,to,open);
} else {
if(cljs.core.truth_(empty)){
return new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"changes","changes",1492088),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"insert","insert",1286475395),[open,close].join(''),new cljs.core.Keyword(null,"from","from",1815293044),head], null),new cljs.core.Keyword(null,"cursor","cursor",1011937484),(head + ((open).length))], null);
} else {
return new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"changes","changes",1492088),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"insert","insert",1286475395),open,new cljs.core.Keyword(null,"from","from",1815293044),from], null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"insert","insert",1286475395),close,new cljs.core.Keyword(null,"from","from",1815293044),to], null)], null),new cljs.core.Keyword(null,"from-to","from-to",-640428401),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [(anchor + ((open).length)),(head + ((open).length))], null)], null);
}

}
}
}));
});
clojure_eval.extensions.close_brackets.handle_close = (function clojure_eval$extensions$close_brackets$handle_close(state,key_name){
return clojure_eval.util.update_ranges.cljs$core$IFn$_invoke$arity$3(state,({"annotations": clojure_eval.util.user_event_annotation("input")}),(function (p__56498){
var map__56499 = p__56498;
var map__56499__$1 = (((((!((map__56499 == null))))?(((((map__56499.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__56499.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__56499):map__56499);
var range = map__56499__$1;
var empty = (function (){var obj56501 = map__56499__$1;
var k56502 = "empty";
if((function (){var obj56503 = obj56501;
return (((!((obj56503 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k56502,obj56503)));
})()){
return (obj56501[k56502]);
} else {
return undefined;
}
})();
var head = (function (){var obj56504 = map__56499__$1;
var k56505 = "head";
if((function (){var obj56507 = obj56504;
return (((!((obj56507 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k56505,obj56507)));
})()){
return (obj56504[k56505]);
} else {
return undefined;
}
})();
var from = (function (){var obj56508 = map__56499__$1;
var k56509 = "from";
if((function (){var obj56510 = obj56508;
return (((!((obj56510 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k56509,obj56510)));
})()){
return (obj56508[k56509]);
} else {
return undefined;
}
})();
var to = (function (){var obj56511 = map__56499__$1;
var k56512 = "to";
if((function (){var obj56513 = obj56511;
return (((!((obj56513 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k56512,obj56513)));
})()){
return (obj56511[k56512]);
} else {
return undefined;
}
})();
if(cljs.core.truth_((function (){var or__4223__auto__ = clojure_eval.extensions.close_brackets.in_string_QMARK_(state,from);
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
return clojure_eval.extensions.close_brackets.escaped_QMARK_(state,from);
}
})())){
return clojure_eval.util.insertion.cljs$core$IFn$_invoke$arity$3(from,to,key_name);
} else {
if(cljs.core.truth_(empty)){
var or__4223__auto__ = (function (){var unbalanced = (function (){var G__56514 = clojure_eval.node.tree.cljs$core$IFn$_invoke$arity$3(state,head,(-1));
var G__56514__$1 = (((G__56514 == null))?null:clojure_eval.node.ancestors(G__56514));
var G__56514__$2 = (((G__56514__$1 == null))?null:cljs.core.filter.cljs$core$IFn$_invoke$arity$2(cljs.core.every_pred.cljs$core$IFn$_invoke$arity$2(clojure_eval.node.coll_QMARK_,cljs.core.complement(clojure_eval.node.balanced_QMARK_)),G__56514__$1));
if((G__56514__$2 == null)){
return null;
} else {
return cljs.core.first(G__56514__$2);
}
})();
var closing = (function (){var G__56515 = unbalanced;
var G__56515__$1 = (((G__56515 == null))?null:clojure_eval.node.down(G__56515));
if((G__56515__$1 == null)){
return null;
} else {
return clojure_eval.node.closed_by(G__56515__$1);
}
})();
var pos = (function (){var G__56516 = unbalanced;
if((G__56516 == null)){
return null;
} else {
return clojure_eval.node.end(G__56516);
}
})();
if(cljs.core.truth_((function (){var and__4221__auto__ = closing;
if(cljs.core.truth_(and__4221__auto__)){
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(closing,key_name);
} else {
return and__4221__auto__;
}
})())){
return new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"changes","changes",1492088),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"from","from",1815293044),pos,new cljs.core.Keyword(null,"insert","insert",1286475395),closing], null),new cljs.core.Keyword(null,"cursor","cursor",1011937484),(pos + (1))], null);
} else {
return null;
}
})();
if(cljs.core.truth_(or__4223__auto__)){
return or__4223__auto__;
} else {
var or__4223__auto____$1 = (function (){var temp__5753__auto__ = (function (){var temp__5753__auto__ = clojure_eval.node.terminal_cursor(clojure_eval.node.tree.cljs$core$IFn$_invoke$arity$1(state),head,(1));
if(cljs.core.truth_(temp__5753__auto__)){
var cursor = temp__5753__auto__;
while(true){
if(clojure_eval.node.right_edge_type_QMARK_(cursor.type)){
return clojure_eval.node.end(cursor);
} else {
if(cljs.core.truth_(cursor.next())){
continue;
} else {
return null;
}
}
break;
}
} else {
return null;
}
})();
if(cljs.core.truth_(temp__5753__auto__)){
var close_node_end = temp__5753__auto__;
return new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"cursor","cursor",1011937484),close_node_end], null);
} else {
return null;
}
})();
if(cljs.core.truth_(or__4223__auto____$1)){
return or__4223__auto____$1;
} else {
return new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"cursor","cursor",1011937484),head], null);
}
}
} else {
return null;
}
}
}));
});
clojure_eval.extensions.close_brackets.handle_backspace_cmd = (function clojure_eval$extensions$close_brackets$handle_backspace_cmd(p__56517){
var map__56518 = p__56517;
var map__56518__$1 = (((((!((map__56518 == null))))?(((((map__56518.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__56518.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__56518):map__56518);
var view = map__56518__$1;
var state = (function (){var obj56520 = map__56518__$1;
var k56521 = "state";
if((function (){var obj56522 = obj56520;
return (((!((obj56522 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k56521,obj56522)));
})()){
return (obj56520[k56521]);
} else {
return undefined;
}
})();
return clojure_eval.util.dispatch_some(view,clojure_eval.extensions.close_brackets.handle_backspace(state));
});
clojure_eval.extensions.close_brackets.handle_open_cmd = (function clojure_eval$extensions$close_brackets$handle_open_cmd(key_name){
return (function (p__56523){
var map__56524 = p__56523;
var map__56524__$1 = (((((!((map__56524 == null))))?(((((map__56524.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__56524.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__56524):map__56524);
var view = map__56524__$1;
var state = (function (){var obj56526 = map__56524__$1;
var k56527 = "state";
if((function (){var obj56528 = obj56526;
return (((!((obj56528 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k56527,obj56528)));
})()){
return (obj56526[k56527]);
} else {
return undefined;
}
})();
return clojure_eval.util.dispatch_some(view,clojure_eval.extensions.close_brackets.handle_open(state,key_name));
});
});
clojure_eval.extensions.close_brackets.handle_close_cmd = (function clojure_eval$extensions$close_brackets$handle_close_cmd(key_name){
return (function (p__56529){
var map__56530 = p__56529;
var map__56530__$1 = (((((!((map__56530 == null))))?(((((map__56530.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__56530.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__56530):map__56530);
var view = map__56530__$1;
var state = (function (){var obj56532 = map__56530__$1;
var k56533 = "state";
if((function (){var obj56534 = obj56532;
return (((!((obj56534 == null)))) && (applied_science.js_interop.impl.in_QMARK__STAR_(k56533,obj56534)));
})()){
return (obj56532[k56533]);
} else {
return undefined;
}
})();
return clojure_eval.util.dispatch_some(view,clojure_eval.extensions.close_brackets.handle_close(state,key_name));
});
});
clojure_eval.extensions.close_brackets.extension = (function clojure_eval$extensions$close_brackets$extension(){
return module$node_modules$$codemirror$view$dist$index_cjs.keymap.of([({}),({"key":"(","run":clojure_eval.extensions.close_brackets.handle_open_cmd("(")}),({"key":"[","run":clojure_eval.extensions.close_brackets.handle_open_cmd("[")}),({"key":"{","run":clojure_eval.extensions.close_brackets.handle_open_cmd("{")}),({"key":"\"","run":clojure_eval.extensions.close_brackets.handle_open_cmd("\"")}),({"key":")","run":clojure_eval.extensions.close_brackets.handle_close_cmd(")")}),({"key":"]","run":clojure_eval.extensions.close_brackets.handle_close_cmd("]")}),({"key":"}","run":clojure_eval.extensions.close_brackets.handle_close_cmd("}")})]);
});

//# sourceMappingURL=clojure_eval.extensions.close_brackets.js.map
